Package org.apache.sysds.runtime.io

# Class ReaderDelta

java.lang.Object
org.apache.sysds.runtime.io.MatrixReader
org.apache.sysds.runtime.io.ReaderDelta

Direct Known Subclasses:
  `ReaderDeltaParallel`

public class ReaderDelta extends MatrixReader
Single-threaded native Delta Lake reader for matrices, built on the Spark-free Delta Kernel library. It opens the latest snapshot of a Delta table directory, reads its parquet data files through the kernel's default engine (honoring deletion vectors), and materializes the numeric columns into a dense `MatrixBlock`.

Only numeric columns (double/float/long/int/short/byte/boolean) are supported, matching the all-double nature of a SystemDS matrix. Dimensions do not need to be known up front: the row count is discovered while scanning and the column count is taken from the table schema.

## Constructor Summary

Constructors
Constructor
Description
`ReaderDelta()`

## Method Summary

Modifier and Type
Method
Description
`MatrixBlock`
`readMatrixFromHDFS(String fname, long rlen, long clen, int blen, long estnnz)`
`MatrixBlock`
`readMatrixFromInputStream(InputStream is, long rlen, long clen, int blen, long estnnz)`

### Methods inherited from class org.apache.sysds.runtime.io.MatrixReader

`checkValidInputFile`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ReaderDelta

public ReaderDelta()

## Method Details

### readMatrixFromHDFS

public MatrixBlock readMatrixFromHDFS(String fname, long rlen, long clen, int blen, long estnnz) throws IOException, DMLRuntimeException

Specified by:
  `readMatrixFromHDFS` in class `MatrixReader`
Throws:
  `IOException`
  `DMLRuntimeException`

### readMatrixFromInputStream

public MatrixBlock readMatrixFromInputStream(InputStream is, long rlen, long clen, int blen, long estnnz) throws IOException, DMLRuntimeException

Specified by:
  `readMatrixFromInputStream` in class `MatrixReader`
Throws:
  `IOException`
  `DMLRuntimeException`